#include <avr/io.h>
#include <util/delay.h>

uint16_t read_adc(uint8_t channel)
{
    ADMUX = 0b01000000; // เลือกใช้แรงดันอ้างอิงจากขา AREF
    ADMUX |= channel;   // ตั้ง MUX ให้ชี้ไปยัง channel
    ADCSRA = 0b11000110;
    while ((ADCSRA & (1<<ADSC))) // รอจนบิต ADSC (บิต 6) กลายเป็น 0
        ;
    return ADCL + ADCH*256;  // ผลลัพธ์ถูกเก็บอยู่ในรีจีสเตอร์ ADCL และ ADCH
}
    /*
	PB0=Yellow1
  	PB1=Green3
	PB3=Yellow2
	PB5=Yellow3
	PB4=Red1
	PC2=Red2
	PC3=Green2
	PC4=Green1
	PC5=Yellow4
    */
int GlobalHighScore;
void SetHigh(int HighScore,int Current)
{
	int Division=GlobalHighScore/6;
	if(Current<Division)
	{
		PORTC= 0b00000000;
		PORTB= 0b00000000;
	}
	else if(Current<Division*2)
	{
		PORTC = 0b00010000;
		PORTB = 0b00000000;
	}
	else if(Current<Division*3)
	{
		PORTC = 0b00011000;
		PORTB = 0b00000000;
	}
	else if(Current<Division*4)
	{
		PORTC = 0b00011000;
		PORTB = 0b00000010;
	}
	else if(Current<Division*5)
	{
		PORTC = 0b00011000;
		PORTB = 0b00000011;
	}
	else if(Current<GlobalHighScore)
	{
		PORTC = 0b00011000;
		PORTB = 0b00001011;
	}
	else if(Current<GlobalHighScore+4)
	{
		PORTC = 0b00011000;
		PORTB = 0b00101011;
	}
	else if(Current<GlobalHighScore+8)
	{
		PORTC = 0b00111000;
		PORTB = 0b00101011;
	}
	else if(Current<GlobalHighScore+16)
	{
		PORTC = 0b00111000;
		PORTB = 0b00111011;
	}
	else if(Current<GlobalHighScore+32)
	{
		PORTC = 0b00111100;
		PORTB = 0b00111011;
	}
	PORTB=PORTB|0b00001000;
}
main()
{
  static uint16_t x;
  DDRC = 0b00111100;
//         76543210
  DDRB = 0b00111011;
//         76543210
  PORTB = 0b00111111;
  PORTC = 0b00111100;
  GlobalHighScore=0;
  int HighScore=0;
  long int count=0;
  while(1)
  {
	Start:
	x = read_adc(1);
	if(x>HighScore)
	{
		HighScore=x;
		count=0;
	}
	SetHigh(HighScore,x);
	if(count>20000)//2.5 sec 40000
	{
		count=0;
		if(GlobalHighScore<HighScore)
			GlobalHighScore=HighScore;
		HighScore=0;
	}
	PORTB |= 0b00000100;
	if(!(PINB & 0b00000100))
	{
		HighScore=count=GlobalHighScore=0;
		PORTB = 0b00001010;
		PORTC = 0b00110100;
		_delay_ms(1000);
		PORTC=PORTB =0b00000000;
		goto Start;
	}
	count++;
  }
}
